//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file as well as the entire HPG library was written by Chris Smith
//& for HPGCC 1.0, now maintained by the HPGCC3 team.
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***



#include <stdlib.h>
#include "hpgraphics.h"
#include "hpgpriv.h"

hpg_t *hpg_alloc_gray4_image(int width, int height)
{
    hpg_init();

    int fbwidth = (width + 3) >> 2; // width of a line in bytes
    char *fb = (char *) malloc(fbwidth * height);
    if (fb == NULL) return NULL;
    hpg_t *img = (hpg_t *) malloc(sizeof(hpg_t));
    if (img == NULL)
    {
        free(fb);
        return NULL;
    }

    img->fb = img->drawfb = fb;
    img->drawfn = _hpg_gray4_draw;
    img->getfn = _hpg_gray4_get;
    img->width = width;
    img->height = height;
    img->fbwidth = fbwidth;
    img->clipx1 = img->clipy1 = 0;
    img->clipx2 = width;
    img->clipy2 = height;
    img->mode = HPG_MODE_PAINT;
    img->color = HPG_COLOR_BLACK;
    img->pattern = NULL;
    img->font = NULL;

    return img;
}
