//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***


// $Id: sys_RTC_seconds.c 514 2007-11-18 03:11:26Z ingo $

#include <sys.h>

// ROMLIB CHECKED

int sys_RTC_seconds()
{
    //read the RTC register
    int sec,min,hour;

    // fixed: (unsigned short*) -> (unsigned char *) since we are reading 8 bit quantities
    // < ibl ; 2004-12-06 >
    // Replaced hardcoded hardware addresses with symbolic constants
    // < ibl ; 2005-06-23 >
    
    sec  = sys_bcd2bin(*(unsigned char*)(RTC_REGS+0x70));
    min  = sys_bcd2bin(*(unsigned char*)(RTC_REGS+0x74)) ;
    hour = sys_bcd2bin(*(unsigned char*)(RTC_REGS+0x78));

    return(sec+60*min+3600*hour);
}



/*
RTC_ss:
    STMFD SP!, {R1,LR} 
    mov    r1,#0x7B00000    @ RTC - BASE
    ldrb    r0,[r1,#0x70]    @ BCD - seconds
    bl    bcd2bin
    LDMFD SP!, {R1,PC}
    
RTC_mm:
    STMFD SP!, {R1,LR} 
    mov    r1,#0x7B00000    @ RTC - BASE
    ldrb    r0,[r1,#0x74]    @ BCD - minutes
    bl    bcd2bin
    LDMFD SP!, {R1,PC}
    
RTC_hh:
    STMFD SP!, {R1,LR} 
    mov    r1,#0x7B00000    @ RTC - BASE
    ldrb    r0,[r1,#0x78]    @ BCD - hours
    bl    bcd2bin
    LDMFD SP!, {R1,PC}
    
*/
