//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***



// $Id: launch_initglobals.c 599 2008-09-01 16:37:15Z claudio $

#include <hpgcc3.h>
#include <master_globals.h>
#include <system_globals.h>
#include "launcher.h"


extern int putchar_console(int);
extern void putcon_stdscreen(int);

void __launch_initglobals(int sat_cpu,int hbase,int nentries)
{

// APPEND GLOBAL STRUCTURES AFTER .bss SECTION AND BEFORE HEAP

__sg= (SYSTEM_GLOBALS *)hbase;		// TEMPORARILY STORE SYSTEM_GLOBALS WITHIN PROGRAM'S ADDRESS SPACE
__mg=(MASTER_GLOBALS *) (hbase+sizeof(SYSTEM_GLOBALS));
hbase+=sizeof(SYSTEM_GLOBALS)+sizeof(MASTER_GLOBALS);


// *****************************
// ZERO-FILL ALL GLOBALS BY DEFAULT
// *****************************

memset((void *)__sg,0,sizeof(SYSTEM_GLOBALS));
memset((void *)__mg,0,sizeof(MASTER_GLOBALS));


// *****************************
// SATURN EMULATOR
// *****************************

__mg->_saturn_cpu=(SAT_CPU *)sat_cpu;


// *****************************
// HEAP MANAGEMENT
// *****************************


__mg->_heap_base_addr=hbase;
__mg->_mmu_table_entries=nentries;


// *****************************
// STRING FUNCTIONS STATE
// *****************************

// < ibl ; 2006-11-30 >

__mg->__strtok_save = "";

// *****************************
// MATH FUNCTIONS STATE
// *****************************

// NO NEED, ALL VARS SET TO 0

// *****************************
// RANDOM NUMBER GENERATOR
// *****************************

// NO NEED, ALL VARS SET TO 0

// *****************************
// STDIO AND SCREEN-RELATED GLOBALS
// *****************************


// NO NEED, __console_type == 0 BY DEFAULT
  
// *****************************
// INTERRUPT STATE
// *****************************

// NO NEED, ALL VARS SET TO 0

// *****************************
// EXIT AND RELATED GLOBALS
// *****************************

// NO NEED, ALL VARS SET TO 0

}

