//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***



// $Id: launch_loader.c 440 2007-08-26 05:49:12Z claudio $

#include <hpgcc3.h>
#include <master_globals.h>
#include <system_globals.h>
#include "launcher.h"


void __launch_loader(unsigned int *data_start, unsigned int data_size,unsigned int bss_size,unsigned int saturn)
{
    register unsigned int *new_bss_base, *ram_ptr;
    register int nitems;

//  READ NON-GLOBAL VARIABLES CREATED BY 'ld'
    ram_ptr=(unsigned int *)0x01101000;    // FIXED DATA SEGMENT START

    new_bss_base=(unsigned int *)((unsigned int) ram_ptr  + data_size);


//  MOVE .data SECTION TO RAM

    nitems=(data_size+3)>>2;

    while( (nitems--)!=0) ram_ptr[nitems]=data_start[nitems];


//  INITIALIZE .bss SECTION TO 0

    nitems=(bss_size+3)>>2;
    while( (nitems--)!=0) new_bss_base[nitems]=0;


	__launch_initglobals(saturn,(unsigned int)new_bss_base+bss_size,*( (unsigned int *) (saturn+0x914)));



// RAM DATA SEGMENT STRUCTURE IS:
// _ram_base: (virtual address = 0x01101000)
// .romglobals section (only pointers to system_globals and master_globals)
// .data SECTION (executable-level initialized globals)
// .bss SECTION (executable-level uninitialized data)
// system_globals
// master_globals
// _heap_start:
// ...free memory...
// stack

}
